Index: palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 2934)
+++ palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 2938)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Initial read of geostrophic wind components from dynamic driver. 
+! 
+! 2773 2018-01-30 14:12:54Z suehring
 ! Revise checks for surface_fraction.
 ! 
@@ -126,4 +129,7 @@
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  zw_atmos         !< vertical levels at w grid in dynamic input file
 
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ug         !< domain-averaged geostrophic component
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vg         !< domain-averaged geostrophic component
+
        REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_left   !< u-component at left boundary
        REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_left   !< v-component at left boundary
@@ -180,6 +186,9 @@
        LOGICAL ::  from_file_tsoil  = .FALSE. !< flag indicating whether soil temperature is already initialized from file 
        LOGICAL ::  from_file_u      = .FALSE. !< flag indicating whether u is already initialized from file 
+       LOGICAL ::  from_file_ug     = .FALSE. !< flag indicating whether ug is already initialized from file 
        LOGICAL ::  from_file_v      = .FALSE. !< flag indicating whether v is already initialized from file 
-       LOGICAL ::  from_file_w      = .FALSE. !< flag indicating whether w is already initialized from file 
+       LOGICAL ::  from_file_vg     = .FALSE. !< flag indicating whether ug is already initialized from file 
+       LOGICAL ::  from_file_w      = .FALSE. !< flag indicating whether w is already initialized from file
+
 
        REAL(wp) ::  fill_msoil       !< fill value for soil moisture
@@ -422,4 +431,8 @@
        MODULE PROCEDURE get_variable_4d_real
     END INTERFACE get_variable
+
+    INTERFACE get_variable_pr
+       MODULE PROCEDURE get_variable_pr
+    END INTERFACE get_variable_pr
 
     INTERFACE get_attribute
@@ -2025,12 +2038,22 @@
              ENDIF
 !
-!--          Read geostrophic wind components
-!              IF ( check_existence( var_names, 'ls_forcing_ug' ) )  THEN
-! 
-!              ENDIF
-!              IF ( check_existence( var_names, 'ls_forcing_vg' ) )  THEN
-! 
-!              ENDIF
-
+!--          Read initial geostrophic wind components at 
+!--          t = 0 (index 1 in file). 
+             IF ( check_existence( var_names, 'ls_forcing_ug' ) )  THEN
+                ALLOCATE( init_3d%ug_init(nzb:nzt+1) )
+                CALL get_variable_pr( id_dynamic, 'ls_forcing_ug', 1,          &
+                                      init_3d%ug_init )
+                init_3d%from_file_ug = .TRUE.
+             ELSE
+                init_3d%from_file_ug = .FALSE.
+             ENDIF
+             IF ( check_existence( var_names, 'ls_forcing_vg' ) )  THEN
+                ALLOCATE( init_3d%vg_init(nzb:nzt+1) )
+                CALL get_variable_pr( id_dynamic, 'ls_forcing_vg', 1,          &
+                                      init_3d%vg_init )
+                init_3d%from_file_vg = .TRUE.
+             ELSE
+                init_3d%from_file_vg = .FALSE.
+             ENDIF
 !
 !--          Read inital 3D data of u, v, w, pt and q, 
@@ -2222,4 +2245,5 @@
 !--          Read soil moisture
              IF ( land_surface )  THEN
+
                 IF ( check_existence( var_names, 'init_soil_m' ) )  THEN
 !
@@ -2240,5 +2264,5 @@
 !
 !--                level-of-detail 2 - read 3D initialization data
-                   ELSEIF ( init_3d%lod_msoil == 2 )  THEN  ! need to be corrected
+                   ELSEIF ( init_3d%lod_msoil == 2 )  THEN
                       ALLOCATE ( init_3d%msoil(0:init_3d%nzs-1,nys:nyn,nxl:nxr) )
                       DO  i = nxl, nxr
@@ -2272,5 +2296,5 @@
 !
 !--                level-of-detail 2 - read 3D initialization data
-                   ELSEIF ( init_3d%lod_tsoil == 2 )  THEN  ! need to be corrected
+                   ELSEIF ( init_3d%lod_tsoil == 2 )  THEN
                       ALLOCATE ( init_3d%tsoil(0:init_3d%nzs-1,nys:nyn,nxl:nxr) )
                       DO  i = nxl, nxr
@@ -2346,6 +2370,8 @@
 
        USE control_parameters,                                                 &
-           ONLY:  force_bound_l, force_bound_n, force_bound_r, force_bound_s,  &
+           ONLY:  bc_lr_cyc, bc_ns_cyc, force_bound_l, force_bound_n,          &
+                  force_bound_r, force_bound_s,                                &
                   forcing, humidity, message_string, neutral, simulated_time
+
 
        USE indices,                                                            &
@@ -2430,5 +2456,16 @@
              force%tind = MINLOC( ABS( force%time - simulated_time ), DIM = 1 )&
                           - 1
-             force%tind_p = force%tind + 1  
+             force%tind_p = force%tind + 1
+!
+!--          Read geostrophic wind components. In case of forcing, this is only
+!--          required if cyclic boundary conditions are applied.
+             IF ( bc_lr_cyc  .AND.  bc_ns_cyc )  THEN
+                DO  t = force%tind, force%tind_p
+                   CALL get_variable_pr( id_dynamic, 'ls_forcing_ug', t+1,     &
+                                         force%ug(t-force%tind,:) )
+                   CALL get_variable_pr( id_dynamic, 'ls_forcing_vg', t+1,     &
+                                         force%ug(t-force%tind,:) )
+                ENDDO
+             ENDIF  
 !
 !--          Read data at lateral and top boundaries. Please note, at left and 
@@ -3832,4 +3869,45 @@
     END SUBROUTINE get_variable_1d_real
 
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Reads a time-dependent 1D float variable from file. 
+!------------------------------------------------------------------------------!
+    SUBROUTINE get_variable_pr( id, variable_name, t, var )
+#if defined( __netcdf )
+
+       USE pegrid
+
+       IMPLICIT NONE
+
+       CHARACTER(LEN=*)                      ::  variable_name    !< variable name 
+
+       INTEGER(iwp), INTENT(IN)              ::  id               !< file id
+       INTEGER(iwp), DIMENSION(1:2)          ::  id_dim           !< dimension ids
+       INTEGER(iwp)                          ::  id_var           !< dimension id
+       INTEGER(iwp)                          ::  n_file           !< number of data-points in file along z dimension
+       INTEGER(iwp), INTENT(IN)              ::  t                !< timestep number
+
+       REAL(wp), DIMENSION(:), INTENT(INOUT) ::  var  !< variable to be read
+
+!
+!--    First, inquire variable ID
+       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
+!
+!--    Inquire dimension size of vertical dimension
+       nc_stat = NF90_INQUIRE_VARIABLE( id, id_var, DIMIDS = id_dim )
+       nc_stat = NF90_INQUIRE_DIMENSION( id, id_dim(1), LEN = n_file )
+!
+!--    Read variable. 
+       nc_stat = NF90_GET_VAR( id, id_var, var,                                &
+                               start = (/ 1,      t     /),                    &
+                               count = (/ n_file, 1     /) )
+       CALL handle_error( 'get_variable_pr', 527 ) 
+
+#endif
+    END SUBROUTINE get_variable_pr
+
+
 !------------------------------------------------------------------------------!
 ! Description:
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 2934)
+++ palm/trunk/SOURCE/parin.f90	(revision 2938)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Change initialization in case child domain should be initialized with Inifor.
+! 
+! 2936 2018-03-27 14:49:27Z suehring
 ! inipar renamed to initialization_parameters.
 ! d3par renamed to runtime_parameters.
@@ -907,9 +910,7 @@
 !--       are set properly. An exception is made in case of restart runs and
 !--       if user decides to do everything by its own.
-!--       MS: is this really necessary?
           IF ( nest_domain  .AND.  .NOT. (                                     &
                TRIM( initializing_actions ) == 'read_restart_data'  .OR.       &
-               TRIM( initializing_actions ) == 'by_user'            .OR.       &
-               TRIM( initializing_actions ) == 'inifor' ) )  THEN
+               TRIM( initializing_actions ) == 'by_user' ) )  THEN
              initializing_actions = 'set_constant_profiles'
           ENDIF
